package poligoni;

public abstract class Poligono
{
	Lato[] lati;

	public Poligono(int numLati)
	{
		lati = new Lato[numLati];
	}

	public Poligono()
	{
		this(3);
	}

	public void setLato(Lato lato, int pos)
	{
		if(lati[pos] != null)//non posso sostituire un lato gia' inserito
		{
			throw (new LatoDuplicatoException());
		}
		lati[pos] = lato;
	}

	public void setLato(int len, int pos)
	{
		this.setLato(new Lato(len), pos);
	}

	public double perimetro()
	{
	}

	public abstract double area();
}
