package figure;

public class ListaLinkataDoppia<E>
implements java.util.List<E>
{
	int numElem;
	NodoDoppio<E> head, tail;

	public ListaLinkataDoppia()
	{
		numElem = 0;
		head = tail = null;
	}

	public boolean add(E e)
	{
		NodoDoppio<E> tmp = new NodoDoppio<E>();
		tmp.contenuto = e;
		if(isEmpty())
		{
			head = tail = tmp;
		}
		else
		{
			tail.next = tmp;
			tmp.prev = tail;
			tail = tail.next;
		}
		numElem++;
		return true;
	}

	public add(int index, E e)
	{
		if(index < 0 || index > size())
		{
			throw new IndexOutOfBoundsException("indice non valido <" + index + ">");
		}

		if(index == size())
		{
			return add(e);
		}

		if(index == 0)
		{
			NodoDoppio<E> tmp = new NodoDoppio<E>();
			tmp.contenuto = e;
			tmp.next = head;
			head.prev = tmp;
			head = tmp;
			numElem++;
			return true;
		}

		NodoDoppio<E> cursore = head;
		while(index > 0)
		{
			cursore = cursore.next;
			index--;
		}
		tmp.next = cursore;
		tmp.prev = cursore.prev;
		tmp.next.prev = tmp;
		tmp.prev.next = tmp;
		numElem++;
		return true;
	}

	class NodoDoppio<E>
	{
		E contenuto = null;
		NodoDoppio<E> next = null;
		NodoDoppio<E> prev = null;
	}
}
