package io;

import java.io.*;

public class TestText
{
	public static void main(String[] argv)
	{
		File f = new File(argv[0]);
		PrintWriter pw = null;
		try
		{
			if(!f.exists())
			{
				if(!f.createNewFile())
				{
					System.out.println("Oops, lo ha creato qualcun altro mentre ero distratto...");
				}
			}
			if(!f.canWrite())
			{
				System.out.println("Non posso scrivere nel file " + argv[0]);
				System.exit(1);
			}

			pw = new PrintWriter(f);
			int i = 1;
			for(i=1;i<argv.length;i++)
			{
				pw.println(argv[i]);
			}

			pw.flush();
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
		}

		if(pw!=null)
		{
			pw.close();
		}
	}
}
