package io;

import java.io.*;

public class TestBinario
{
	public static void main(String[] argv)
	{
		int i = 0;
		FileOutputStream fos = null;
		DataOutputStream dos = null;
		try
		{
			File f = new File(argv[0]);
			if(!f.exists())
			{
				if(!f.createNewFile())
				{
					System.out.println("Oops, lo ha creato qualcun altro mentre ero distratto...");
				}
			}
			if(!f.canWrite())
			{
				System.out.println("Non posso scrivere nel file " + argv[0]);
				System.exit(1);
			}
			fos = new FileOutputStream(f);
			dos = new DataOutputStream(fos);

			for(i=1;i<argv.length;i++)
			{
				dos.writeUTF(argv[i]);
				dos.writeInt(Integer.parseInt(argv[i]));
			}
			dos.flush();
		}
		catch(FileNotFoundException fnfe)
		{
			fnfe.printStackTrace();
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
		}

		try
		{
			dos.close();
		}
		catch(IOException ioe2)
		{
			ioe2.printStackTrace();
		}
	}
}
