public class Sedia
{
	private boolean aperta = false;
	private boolean occupata = false;

	private static int apertaCount;
	private static int occupataCount;

	public boolean apri()
	{
		if(aperta == true)
		{
			return false;
		}
		aperta = true;
		apertaCount++;
		return true;
	}

	public boolean chiudi()
	{
		if( (!aperta || occupata) == true)
		{
			return false;
		}
		/*
		if(occupata)
		{
			return false;
		}
		*/
		aperta = false;
		apertaCount++;
		return true;
	}

	public boolean occupa()
	{
		if(!aperta || occupata)
		{
			return false;
		}
		occupata = true;
		occupataCount++;
		return true;
	}

	public boolean libera()
	{
		if(!aperta || !occupata)
		{
			return false;
		}
		occupata = false;
		occupataCount++;
		return true;
	}

	public boolean isAperta()
	{
		return aperta;
	}

	public boolean isOccupata()
	{
		return occupata;
	}

	public static int quanteAperture()
	{
		return apertaCount;
	}

	public static int quanteOccupazioni()
	{
		return occupataCount;
	}

	public static void main(String[] argv)
	{
		//int i;
		//System.out.println(occupata); non compila perche' il campo non e' static


		Sedia s = new Sedia();
		System.out.println(s.occupata);
	}

	static
	{
		System.out.println("Adesso eseguo l'inizializzatore statico e assegno 0 ai contatori");
		apertaCount = occupataCount = 0;
		System.out.println("Fine inizializzatore statico");
	}
}
