package figure;

import java.util.*;
import java.io.*;

public class InsertionSort
{
	public static void main(String[] argv)
	{
		// e' possibile sostituire con qualsiasi implementazione completa
		// dell'interfaccia List
		List<Comparable> list = new LinkedList<Comparable>();
		BufferedReader br = null;
		try
		{
			File f = new File(argv[0]);
			br = new BufferedReader(new FileReader(f));
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
			System.exit(1);
		}

		Popolabile p = null;
		String tipo = null;
		try
		{
			while( (tipo = br.readLine()) != null)
			{
				if(tipo.equals("Triangolo"))
				{
					p = new Triangolo();
				}
				else if(tipo.equals("Quadrato"))
				{
					p =new Quadrato();
				}
				else
				{
					System.err.println("Tipo <" + tipo + "> non noto");
					continue;
				}
	
				p.popola(br);
				Comparable integer = (Comparable)p;
	
				ListIterator<Comparable> li = list.listIterator();
				while(li.hasNext())
				{
					Comparable corrente = li.next();
					//if(corrente.intValue() > integer.intValue())
					if(corrente.compareTo(integer) > 0)
					{
						li.previous();
						li.add(integer);
						break;
					}
				}
				if(!li.hasNext())//vuol dire che sono uscito per fine lista
				{
					//allora inserisco in fondo
					li.add(integer);
				}
				p = null;
	
				System.out.println(list);
			}
		}
		catch(IOException ioe2)
		{
			ioe2.printStackTrace();
		}

		try
		{
			br.close();
		}
		catch(IOException ioe3)
		{
			ioe3.printStackTrace();
		}
		System.out.println(list);
	}
}
