package io;
import java.io.*;

public class ReadBinario
{
	public static void main(String[] argv)
	{
		File f;
		FileInputStream fis;
		DataInputStream dis = null;

		try
		{
			f = new File(argv[0]);
			if(!f.exists())
			{
				System.out.println("Che vuoi da me?");
				System.exit(1);
			}
			if(!f.canRead())
			{
				System.out.println("Non posso leggere il file " + argv[0]);
				System.exit(1);
			}

			fis = new FileInputStream(f);
			dis = new DataInputStream(fis);

			while(true)
			{
				String s = dis.readUTF();
				int s2 = dis.readInt();
				System.out.println("Ho letto: " + s + ", " + s2);
			}
		}
		catch(EOFException eofe)
		{
			System.out.println("Sono arrivato in fondo al file");
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
		}

		try
		{
			if(dis!=null)
			{
				dis.close();
			}
		}
		catch(IOException ioe2)
		{
			ioe2.printStackTrace();
		}
	}
}
