package poligoni;

/**
* Il rettangolo e' un poligono con 4 lati, tutti gli angoli retti, i lati opposti uguali. La base e' memorizzata in lati[0] e l'altezza in lati[1]. Lati[2] e lati[3] possono non essere inizializzati.
*/
public class Rettangolo
extends Poligono
{
	public Rettangolo(double b, double h)
	{
		super(4);
		try
		{
			setLato(new Lato(b), 0);
			setLato(new Lato(h), 1);
		}
		catch(LatoDuplicatoException lde)
		{
			System.out.println("Non puo' accadere");
			throw new RuntimeException("Lato duplicato nel costruttore di Rettangolo");
		}

		/*
		Lato base = new Lato(b);
		Lato altezza = new Lato(h);
		setLato(base, 0);
		setLato(altezza, 0);
		*/
		System.out.println("Il costruttore di rettangolo ha funzionato a dovere");
	}

	public Rettangolo()
	{
		this(1.0, 10.0);
		System.out.println("Rettangolo()");
	}

	public double area()
	{
		System.out.println("Rettangolo.area");
		double base = lati[0].getLunghezza();
		double altezza = lati[1].getLunghezza();
		return base*altezza;
	}

	public double perimetro()
	{
		System.out.println("Rettangolo.perimetro");
		return 2*(lati[0].getLunghezza() + lati[1].getLunghezza());
	}
}
