package struttureDinamiche;

import java.util.NoSuchElementException;

public class StackDinamico
implements interfacce.Stack, interfacce.Stringhificabile
{
	NodoDoppio head;
	int size;

	public Object searchAndRemove(Object o)
	{
		throw new UnsupportedOperationException();
	}

	public boolean empty()
	{
		return size == 0;
	}

	public Object peek()
	{
		if(empty())
		{
			throw new NoSuchElementException("Stack vuoto");
		}
		return head.contenuto;
	}

	public Object pop()
	{
		if(empty())
		{
			throw new NoSuchElementException("Stack vuoto");
		}
		Object retval = head.contenuto;
		head = head.next;
		if(head != null)
		{
			head.prev.next = null;
			head.prev = null;
		}
		size--;
		return retval;
	}

	public int push(Object elem)
	{
		NodoDoppio tmp = new NodoDoppio();
		tmp.contenuto = elem;
		tmp.next = head;
		if(head != null)
		{
			head.prev = tmp;
		}
		head = tmp;
		return ++size;
	}

	public int search(Object elem)
	{
		int cont = 0;
		NodoDoppio tmp = head;
		while(tmp != null)
		{
			if(elem == null)
			{
				if(tmp.contenuto == null)
				{
					return cont;
				}
			}
			else
			{
				if(elem.equals(tmp.contenuto))
				{
					return cont;
				}
			}
			cont++;
			tmp = tmp.next;
		}
		return -1;
	}

	public int size()
	{
		return size;
	}

	public String toString()
	{
		String retval = "[";
		NodoDoppio tmp = head;
		while(tmp != null)
		{
			retval = retval.concat(String.valueOf(tmp.contenuto));
			if(tmp.next != null)
			{
				retval = retval.concat(", ");
			}
			tmp = tmp.next;
		}
		retval = retval.concat("]");
		return retval;
	}

	public boolean equals(Object o)
	{
		//Limita la "schizzinosita' " di Java
		/*
		if( !(o instanceof StackDinamico))
		{
			return false;
		}
		*/
		StackDinamico sd = (StackDinamico)o;
		if(sd.size != size)
		{
			return false;
		}

		NodoDoppio tmp = head;
		NodoDoppio tmp1 = sd.head;

		while(tmp != null)
		{
			if(tmp.contenuto == null)
			{
				if(tmp1.contenuto != null)
				{
					return false;
				}
			}
			else
			{
				if(!tmp.contenuto.equals(tmp1.contenuto))
				{
					return false;
				}
			}
			tmp = tmp.next;
			tmp1 = tmp1.next;
		}
		return true;
	}
}
