package poligoni;

public class Quadrato
extends Rettangolo
{
	public Quadrato(int l)
	{
		super(l, l);
		//lati = new Lato[4]; non serve, viene fatto nel costruttore della classe base
		try
		{
			setLato(l, 2);
			setLato(l, 3);
		}
		catch(LatoDuplicatoException lde)
		{
			System.err.println("Non puo' accadere");
			throw new RuntimeException("Costruttore Quadrato");
		}
	}

	/* Tutti i lati sono settati alla costruzione. E' sufficiente ereditare
	* il metodo setLato (in entrambe le versioni) dalla classe base
	* perche' come prima operazione effettua il controllo di lato duplicato.
	*/
	/*
	public void setLato(Lato l, int pos) throws LatoDuplicatoException
	{
		if(pos!=0)
		{
			throw new RuntimeException("Il quadrato ha un solo lato settato perche' sono tutti uguali");
		}
		super.setLato(l, pos);
	}

	public void setLato(int l, int pos) throws LatoDuplicatoException
	{
		setLato(new Lato(l), pos);
	}
	*/

	public double perimetro()
	{
		System.out.println("Quadrato.perimetro");
		return lati[0].getLunghezza()*4;
	}

	public double area()
	{
		System.out.println("Quadrato.area");
		double len = lati[0].getLunghezza();
		return len*len;
	}

	public String toString()
	{
		return super.toString() + " tutti lunghi uguali e precisamente " + lati[0].getLunghezza();
	}
}
