package struttureDinamiche;

import interfacce.Stack;

public class StackLinkSingolo
implements Stack, interfacce.Stringhificabile
{
	int size = 0;
	NodoSingolo head = null;

	public Object peek()
	{
		throw new UnsupportedOperationException();
	}

	public Object pop()
	{
		throw new UnsupportedOperationException();
	}

	public int search(Object o)
	{
		throw new UnsupportedOperationException();
	}

	public Object searchAndRemove(Object o)
	{
		if(empty())
		{
			return null;
		}

		if( (head.contenuto == null && o == null) || (head.contenuto != null && head.contenuto.equals(o)))
		{
			Object retval = head.contenuto;
			head = head.next;
			size--;
			return retval;
		}

		NodoSingolo tmp1, tmp2;
		tmp1 = head;
		tmp2 = head.next;
		while(tmp2 != null)
		{
			if( (tmp2.contenuto == null && o == null) || (tmp2.contenuto != null && tmp2.contenuto.equals(o)))
			{
				Object retval = tmp2.contenuto;
				tmp1.next = tmp2.next;
				tmp2.next = null;
				size--;
				return retval;
			}
			tmp1 = tmp1.next;
			tmp2 = tmp2.next;
		}
		return null;
	}

	public int push(Object o)
	{
		NodoSingolo tmp = new NodoSingolo();
		tmp.contenuto = o;
		tmp.next = head;
		head = tmp;
		return ++size;
	}

	public boolean empty()
	{
		return size == 0;
	}

	public String toString()
	{
		String retval = "[";
		NodoSingolo tmp = head;
		while(tmp != null)
		{
			retval = retval.concat(String.valueOf(tmp.contenuto) + ", ");
			tmp = tmp.next;
		}
		retval = retval.concat("]");
		return retval;
	}

	class NodoSingolo
	{
		NodoSingolo next;
		Object contenuto;
	}
}
