package io;

import java.io.*;

public class ReadText
{
	public static void main(String[] argv)
	{
		File f = null;
		BufferedReader br = null;
		try
		{
			if(argv.length > 0)
			{
				f = new File(argv[0]);
				if(!f.exists())
				{
					System.out.println("Che vuoi da me?");
					System.exit(1);
				}
				if(!f.canRead())
				{
					System.out.println("Non posso leggere il file " + argv[0]);
					System.exit(1);
				}
			}

			if(f != null)
			{
				br = new BufferedReader(new FileReader(f));
			}
			else
			{
				br = new BufferedReader(new InputStreamReader(System.in));
			}

			String line = null;
			int i =1;
			while( (line = br.readLine()) != null)
			{
				System.out.println((i++) + "\t" + line);
			}

			br.close();
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
		}
	}
}

